      REAL*8 DDJULI

      WRITE(6,*) 'Year, Month, Day, Hour, Min., Sec. (I,I,I,I,I,R) ?'
      READ (5,*) IY,IM,ID,IH,IMIN,SEC
      WRITE(6,'(1X,A22,F15.6)')
     +  'Julian day          = ',DDJULI(IY,IM,ID,IH,IMIN,SEC)
      WRITE(6,'(1X,A22,F15.6)')
     +  'C. long. of the sun = ',ASUN  (IY,IM,ID,IH,IMIN,SEC)
      WRITE(6,'(1X,A22,F15.6)')
     +  'Solar declination   = ',ASDEC (IY,IM,ID,IH,IMIN,SEC)
      WRITE(6,'(1X,A22,F15.6)')
     +  'Age of the moon     = ',AMOON (IY,IM,ID,IH,IMIN,SEC)

      STOP
      END

C ========================================
C   ASTRONOMICAL CALENDAR
C ========================================

      REAL FUNCTION ASUN (IY,IM,ID,IH,IMIN,SEC)
      REAL*8 DSUN,DDJD,DDJ0,DDJ1,DDJULI
      DDJ0 = DDJULI(2001,03,20,13,31,0.0E0)
      DDJ1 = DDJULI(IY,IM,ID,IH,IMIN,SEC)
      DDJD =   DBLE(365)
     +       + DBLE(05)/DBLE(24)
     +       + DBLE(48)/DBLE(1440) + DBLE(45.243)/DBLE(86400)
      DSUN = DDJ1 - DDJ0
   11 CONTINUE
      IF ((DSUN.GE.0.0E0).AND.(DSUN.LT.DDJD)) GO TO 19
      IF (DSUN.LT.0.0E0) DSUN = DSUN + DDJD
      IF (DSUN.GE.DDJD ) DSUN = DSUN - DDJD
      GO TO 11
   19 CONTINUE
      ASUN = 0.360E3*REAL(DSUN/DDJD)
      RETURN
      END

      REAL FUNCTION ASDEC (IY,IM,ID,IH,IMIN,SEC)
      PI = 0.31415926535E1
      D0 =   DBLE(23)
     +     + DBLE(26)/DBLE(60) + DBLE(20.512)/DBLE(3600)
      TH = PI*ASUN(IY,IM,ID,IH,IMIN,SEC)/0.180E3
      ASDEC = D0 * SIN(TH)
      RETURN
      END

      REAL FUNCTION AMOON (IY,IM,ID,IH,IMIN,SEC)
      REAL*8 DMOON,DDJD,DDJ0,DDJ1,DDJULI
      DDJ0 = DDJULI(2001,01,24,13,07,0.0E0)
      DDJ1 = DDJULI(IY,IM,ID,IH,IMIN,SEC)
      DDJD =   DBLE(29)
     +       + DBLE(12)/DBLE(24)
     +       + DBLE(44)/DBLE(1440) + DBLE(02.877)/DBLE(86400)
      DMOON = DDJ1 - DDJ0
   11 CONTINUE
      IF ((DMOON.GE.0.0E0).AND.(DMOON.LT.DDJD)) GO TO 19
      IF (DMOON.LT.0.0E0) DMOON = DMOON + DDJD
      IF (DMOON.GE.DDJD ) DMOON = DMOON - DDJD
      GO TO 11
   19 CONTINUE
      AMOON = REAL(DMOON)
      RETURN
      END

      REAL FUNCTION AMOONR (IY,IM,ID,IH,IMIN,SEC)
      REAL*8 DMOON,DDJD,DDJ0,DDJ1,DDJULI
      DDJ0 = DDJULI(2001,01,24,13,07,0.0E0)
      DDJ1 = DDJULI(IY,IM,ID,IH,IMIN,SEC)
      DDJD =   DBLE(29)
     +       + DBLE(12)/DBLE(24)
     +       + DBLE(44)/DBLE(1440) + DBLE(02.877)/DBLE(86400)
      DMOON = DDJ1 - DDJ0
   11 CONTINUE
      IF ((DMOON.GE.0.0E0).AND.(DMOON.LT.DDJD)) GO TO 19
      IF (DMOON.LT.0.0E0) DMOON = DMOON + DDJD
      IF (DMOON.GE.DDJD ) DMOON = DMOON - DDJD
      GO TO 11
   19 CONTINUE
      AMOONR = REAL(DMOON/DDJD)
      RETURN
      END

      REAL*8 FUNCTION DDJULI (IY,IM,ID,IH,IMIN,SEC)
      DDJULI =   DBLE(IDJULI(IY,IM,ID)) - 0.5D0
     +         + DBLE(IH)/DBLE(24)
     +         + DBLE(IMIN)/DBLE(1440) + DBLE(SEC)/DBLE(86400)
      RETURN
      END

C ========================================
C   CALENDAR
C ========================================

      INTEGER FUNCTION IDMAX (IY,IM)
      IF (IM.EQ. 1) IDMAX = 31
      IF (IM.EQ. 2) IDMAX = 28
      IF (IM.EQ. 3) IDMAX = 31
      IF (IM.EQ. 4) IDMAX = 30
      IF (IM.EQ. 5) IDMAX = 31
      IF (IM.EQ. 6) IDMAX = 30
      IF (IM.EQ. 7) IDMAX = 31
      IF (IM.EQ. 8) IDMAX = 31
      IF (IM.EQ. 9) IDMAX = 30
      IF (IM.EQ.10) IDMAX = 31
      IF (IM.EQ.11) IDMAX = 30
      IF (IM.EQ.12) IDMAX = 31
      IF (IM.EQ. 2) THEN
      IF (IY.GE.1600) THEN
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
            IF (MOD(IY,100).EQ.0) THEN
              IDMAX = 28
                IF (MOD(IY,400).EQ.0) THEN
                  IDMAX = 29
        ENDIF
        ENDIF
        ENDIF
      ELSE
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
        ENDIF
      ENDIF
      ENDIF
      RETURN
      END

      INTEGER FUNCTION IDYEAR (IY,IM,ID)
        IDYEAR = 0
      DO 11 IMM=1,IM-1
        IDYEAR = IDYEAR + IDMAX(IY,IMM)
   11 CONTINUE
        IDYEAR = IDYEAR + ID
      RETURN
      END

      INTEGER FUNCTION IDJULI (IY,IM,ID)
        IDJULI = 2305447
      IF (IY.GE.1600) THEN
      DO 11 IYY=1600,IY-1
        IDJULI = IDJULI + IDYEAR(IYY,12,31)
   11 CONTINUE
      ELSE
        IDJULI = IDJULI + 10
      DO 12 IYY=IY,1599
        IDJULI = IDJULI - IDYEAR(IYY,12,31)
   12 CONTINUE
      ENDIF
        IDJULI = IDJULI + IDYEAR(IY,IM,ID)
      RETURN
      END

      INTEGER FUNCTION IDWEEK (IY,IM,ID)
      IDWEEK = MOD(IDJULI(IY,IM,ID)-1+2,7) + 1
      RETURN
      END

      CHARACTER*3 FUNCTION CWEEK (IWEEK)
      IF (IWEEK.EQ. 1) CWEEK = 'Sun'
      IF (IWEEK.EQ. 2) CWEEK = 'Mon'
      IF (IWEEK.EQ. 3) CWEEK = 'Tue'
      IF (IWEEK.EQ. 4) CWEEK = 'Wed'
      IF (IWEEK.EQ. 5) CWEEK = 'Thu '
      IF (IWEEK.EQ. 6) CWEEK = 'Fri'
      IF (IWEEK.EQ. 7) CWEEK = 'Sat'
      RETURN
      END
