C   For a year before 1599, Gregorian calendar is assumed.
C   For a year before 1600, Julian calendar is assumed.
C   e.g., For Januay 1, 4712 B.C. (Gregorian) (IY=-4713, IM=1, ID=1),
C           Julian day is 0.
C         For December 21, 1599 A.D. (Gregorian) (IY=1599, IM=12, ID=21),
C           Julian day is 2305447.
C         For January 1, 1600 A.D. (Julian) (IY=1600, IM=1, ID=1),
C           Julian day is 2305448.
C   Note: It differs in different countries when the Julian calendar
C         was adapted.

      CHARACTER CWEEK*3

      WRITE(6,*) 'Year, Month, Day ?'
      READ (5,*) IY,IM,ID
      WRITE(6,'(1X,A18,I8)') 'Day of the year = ',IDYEAR(IY,IM,ID)
      WRITE(6,'(1X,A18,I8)') 'Julian day      = ',IDJULI(IY,IM,ID)
      WRITE(6,'(1X,A18,A3)')
     +  'Day of the week = ',CWEEK(IDWEEK(IY,IM,ID))

      STOP
      END

C ========================================
C   CALENDAR
C ========================================

      INTEGER FUNCTION IDMAX (IY,IM)
      IF (IM.EQ. 1) IDMAX = 31
      IF (IM.EQ. 2) IDMAX = 28
      IF (IM.EQ. 3) IDMAX = 31
      IF (IM.EQ. 4) IDMAX = 30
      IF (IM.EQ. 5) IDMAX = 31
      IF (IM.EQ. 6) IDMAX = 30
      IF (IM.EQ. 7) IDMAX = 31
      IF (IM.EQ. 8) IDMAX = 31
      IF (IM.EQ. 9) IDMAX = 30
      IF (IM.EQ.10) IDMAX = 31
      IF (IM.EQ.11) IDMAX = 30
      IF (IM.EQ.12) IDMAX = 31
      IF (IM.EQ. 2) THEN
      IF (IY.GE.1600) THEN
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
            IF (MOD(IY,100).EQ.0) THEN
              IDMAX = 28
                IF (MOD(IY,400).EQ.0) THEN
                  IDMAX = 29
        ENDIF
        ENDIF
        ENDIF
      ELSE
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
        ENDIF
      ENDIF
      ENDIF
      RETURN
      END

      INTEGER FUNCTION IDYEAR (IY,IM,ID)
        IDYEAR = 0
      DO 11 IMM=1,IM-1
        IDYEAR = IDYEAR + IDMAX(IY,IMM)
   11 CONTINUE
        IDYEAR = IDYEAR + ID
      RETURN
      END

      INTEGER FUNCTION IDJULI (IY,IM,ID)
        IDJULI = 2305447
      IF (IY.GE.1600) THEN
      DO 11 IYY=1600,IY-1
        IDJULI = IDJULI + IDYEAR(IYY,12,31)
   11 CONTINUE
      ELSE
        IDJULI = IDJULI + 10
      DO 12 IYY=IY,1599
        IDJULI = IDJULI - IDYEAR(IYY,12,31)
   12 CONTINUE
      ENDIF
        IDJULI = IDJULI + IDYEAR(IY,IM,ID)
      RETURN
      END

      SUBROUTINE CLYEAR (IY,I,IM,ID)
      II = MOD(I-1,IDYEAR(IY,12,31))+1
      IDX = 0
      DO 11 IMM=1,12
      IF (I.LE.IDX+IDMAX(IY,IMM)) THEN
        IM = IMM
        ID = II - IDX
        RETURN
      ENDIF
        IDX = IDX + IDMAX(IY,IMM)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE CLJULI (IDJ,IY,IM,ID)
      IF (IDJ.GE.IDJULI(2001,1,1)) THEN
      IYR = 2001
   11 CONTINUE
      IF ((IDJ.GE.IDJULI(IYR,1,1)).AND.(IDJ.LT.IDJULI(IYR+1,1,1))) THEN
        IY = IYR
        GO TO 19
      ENDIF
      IYR = IYR + 1
      GO TO 11
      ELSE
      IYR = 2000
   12 CONTINUE
      IF ((IDJ.GE.IDJULI(IYR,1,1)).AND.(IDJ.LT.IDJULI(IYR+1,1,1))) THEN
        IY = IYR
        GO TO 19
      ENDIF
      IYR = IYR - 1
      GO TO 12
      ENDIF
   19 CONTINUE
      CALL CLYEAR (IY,1+IDJ-IDJULI(IY,1,1),IM,ID)
      RETURN
      END

      INTEGER FUNCTION IDWEEK (IY,IM,ID)
      IDWEEK = MOD(IDJULI(IY,IM,ID)-1+2,7) + 1
      RETURN
      END

C ========================================

      CHARACTER*4 FUNCTION CMONTH(IM)
      IF (IM.EQ. 1) CMONTH = 'Jan.'
      IF (IM.EQ. 2) CMONTH = 'Feb.'
      IF (IM.EQ. 3) CMONTH = 'Mar.'
      IF (IM.EQ. 4) CMONTH = 'Apr.'
      IF (IM.EQ. 5) CMONTH = 'May '
      IF (IM.EQ. 6) CMONTH = 'Jun.'
      IF (IM.EQ. 7) CMONTH = 'Jul.'
      IF (IM.EQ. 8) CMONTH = 'Aug.'
      IF (IM.EQ. 9) CMONTH = 'Sep.'
      IF (IM.EQ.10) CMONTH = 'Oct.'
      IF (IM.EQ.11) CMONTH = 'Nov.'
      IF (IM.EQ.12) CMONTH = 'Dec.'
      RETURN
      END

      CHARACTER*3 FUNCTION CWEEK (IWEEK)
      IF (IWEEK.EQ. 1) CWEEK = 'Sun'
      IF (IWEEK.EQ. 2) CWEEK = 'Mon'
      IF (IWEEK.EQ. 3) CWEEK = 'Tue'
      IF (IWEEK.EQ. 4) CWEEK = 'Wed'
      IF (IWEEK.EQ. 5) CWEEK = 'Thu '
      IF (IWEEK.EQ. 6) CWEEK = 'Fri'
      IF (IWEEK.EQ. 7) CWEEK = 'Sat'
      RETURN
      END
