      REAL FUNCTION HANGL (SLM,RA,AL,TZ,T)
      PI = 0.4E1*ATAN(1.0E0)
      HANGL = SLM - RA + T - TZ + AL + PI
      HANGL = AMOD(HANGL,0.2E1*PI)
      IF (HANGL.LT.0.0E0) HANGL = HANGL + 0.2E1*PI
      RETURN
      END

      SUBROUTINE EQ2HR (PH,HA,DL,AZ,EL)
      XX = -COS(DL)*SIN(HA)
      YY = -COS(DL)*COS(HA)
      ZZ = SIN(DL)
      Y = XX
      X = + YY * SIN(PH) + ZZ * COS(PH)
      Z = - YY * COS(PH) + ZZ * SIN(PH)
      CALL POLAR (X,Y,Z,AZ,EL)
      RETURN
      END

      SUBROUTINE POLAR (X,Y,Z,A,D)
      PI = 0.4E1*ATAN(1.0E0)
      R = SQRT(X**2+Y**2+Z**2)
      ZZ = Z/R
      D = ASIN(ZZ)
      A = ATAN(Y/X)
      IF (X.LT.0.0E0) A = A + PI
      IF (A.LT.0.0E0) A = A + 0.2E1*PI
      RETURN
      END

      SUBROUTINE SOLAR (IM,ID,SLM,SL,RA,DL)
      PI = 0.4E1*ATAN(1.0E0)
      DC = 0.234E2*PI/0.180E3
      EP = 0.167E-1
      SLM = 0.2E1*PI*REAL(IDYEAR(2001,IM,ID)-IDYEAR(2001,3,20))/0.365E3
      IF (SLM.LT.0.0E0) SLM = SLM+0.2E1*PI
      SL = SLM+EP*SIN(0.2E1*PI
     +     *REAL(IDYEAR(2001,IM,ID)-IDYEAR(2001,1,5))/0.365E3)
      X = COS(SL)
      Y = COS(DC)*SIN(SL)
      RA = ATAN(Y/X)
      IF (X.LT.0.0E0) RA = RA + PI
      IF (RA.LT.0.0E0) RA = RA + 0.2E1*PI
      DL = DC*SIN(SL)
      RETURN
      END

      REAL FUNCTION TNOON (AL,TZ,SL,RA)
      PI = 0.4E1*ATAN(1.0E0)
      TNOON = PI + RA - SL - AL + TZ
      TNOON = AMOD(TNOON,0.2E1*PI)
      IF (TNOON.LT.0.0E0) TNOON = TNOON + 0.2E1*PI
      RETURN
      END

      REAL FUNCTION SDURA (PH,DL)
      PI = 0.4E1*ATAN(1.0E0)
      COSD = - TAN(DL)*TAN(PH)
      IF (COSD.LT.-1.0E0) COSD = -1.0E0
      IF (COSD.GT.+1.0E0) COSD = +1.0E0
      SDURA = 0.2E1*ACOS(COSD)
      RETURN
      END

      REAL FUNCTION SDURL (PH,DL,EL)
      PI = 0.4E1*ATAN(1.0E0)
C      EL = -0.6E1*PI/0.180E3
C      EL = -0.12E2*PI/0.180E3
C      EL = -0.18E2*PI/0.180E3
      COSD = - TAN(DL)*TAN(PH) + SIN(EL)/COS(DL)/COS(PH)
      IF (COSD.LT.-1.0E0) COSD = -1.0E0
      IF (COSD.GT.+1.0E0) COSD = +1.0E0
      SDURL = 0.2E1*ACOS(COSD)
      RETURN
      END

      SUBROUTINE SRISE (PH,AL,TZ,SL,RA,DL,T1,T2)
      PI = 0.4E1*ATAN(1.0E0)
      T1 = TNOON(AL,TZ,SL,RA) - 0.5E0*SDURA(PH,DL)
      T2 = TNOON(AL,TZ,SL,RA) + 0.5E0*SDURA(PH,DL)
      T1 = AMOD(T1,0.2E1*PI)
      IF (T1.LT.0.0E0) T1 = T1 + 0.2E1*PI
      T2 = AMOD(T2,0.2E1*PI)
      IF (T2.LT.0.0E0) T2 = T2 + 0.2E1*PI
      RETURN
      END

      SUBROUTINE SRISL (PH,AL,TZ,SL,RA,DL,EL,T1,T2)
      PI = 0.4E1*ATAN(1.0E0)
      T1 = TNOON(AL,TZ,SL,RA) - 0.5E0*SDURL(PH,DL,EL)
      T2 = TNOON(AL,TZ,SL,RA) + 0.5E0*SDURL(PH,DL,EL)
      T1 = AMOD(T1,0.2E1*PI)
      IF (T1.LT.0.0E0) T1 = T1 + 0.2E1*PI
      T2 = AMOD(T2,0.2E1*PI)
      IF (T2.LT.0.0E0) T2 = T2 + 0.2E1*PI
      RETURN
      END

      REAL FUNCTION AMAGE (IY,IM,ID)
      T0 = 0.29530588854167E2
      T = REAL(IDJULI(IY,IM,ID)-IDJULI(2001,1,24))-0.546527777778E0
      AMAGE = AMOD(T,T0)
      IF (AMAGE.LT.0.0E0) AMAGE = AMAGE + T0
      RETURN
      END

C ========================================
C   CALENDAR
C ========================================

      INTEGER FUNCTION IDMAX (IY,IM)
      IF (IM.EQ. 1) IDMAX = 31
      IF (IM.EQ. 2) IDMAX = 28
      IF (IM.EQ. 3) IDMAX = 31
      IF (IM.EQ. 4) IDMAX = 30
      IF (IM.EQ. 5) IDMAX = 31
      IF (IM.EQ. 6) IDMAX = 30
      IF (IM.EQ. 7) IDMAX = 31
      IF (IM.EQ. 8) IDMAX = 31
      IF (IM.EQ. 9) IDMAX = 30
      IF (IM.EQ.10) IDMAX = 31
      IF (IM.EQ.11) IDMAX = 30
      IF (IM.EQ.12) IDMAX = 31
      IF (IM.EQ. 2) THEN
      IF (IY.GE.1600) THEN
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
            IF (MOD(IY,100).EQ.0) THEN
              IDMAX = 28
                IF (MOD(IY,400).EQ.0) THEN
                  IDMAX = 29
        ENDIF
        ENDIF
        ENDIF
      ELSE
        IF (MOD(IY,4).EQ.0) THEN
          IDMAX = 29
        ENDIF
      ENDIF
      ENDIF
      RETURN
      END

      INTEGER FUNCTION IDYEAR (IY,IM,ID)
        IDYEAR = 0
      DO 11 IMM=1,IM-1
        IDYEAR = IDYEAR + IDMAX(IY,IMM)
   11 CONTINUE
        IDYEAR = IDYEAR + ID
      RETURN
      END

      INTEGER FUNCTION IDJULI (IY,IM,ID)
        IDJULI = 2305447
      IF (IY.GE.1600) THEN
      DO 11 IYY=1600,IY-1
        IDJULI = IDJULI + IDYEAR(IYY,12,31)
   11 CONTINUE
      ELSE
        IDJULI = IDJULI + 10
      DO 12 IYY=IY,1599
        IDJULI = IDJULI - IDYEAR(IYY,12,31)
   12 CONTINUE
      ENDIF
        IDJULI = IDJULI + IDYEAR(IY,IM,ID)
      RETURN
      END

      SUBROUTINE CLYEAR (IY,I,IM,ID)
      II = MOD(I-1,IDYEAR(IY,12,31))+1
      IDX = 0
      DO 11 IMM=1,12
      IF (I.LE.IDX+IDMAX(IY,IMM)) THEN
        IM = IMM
        ID = II - IDX
        RETURN
      ENDIF
        IDX = IDX + IDMAX(IY,IMM)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE CLJULI (IDJ,IY,IM,ID)
      IF (IDJ.GE.IDJULI(2001,1,1)) THEN
      IYR = 2001
   11 CONTINUE
      IF ((IDJ.GE.IDJULI(IYR,1,1)).AND.(IDJ.LT.IDJULI(IYR+1,1,1))) THEN
        IY = IYR
        GO TO 19
      ENDIF
      IYR = IYR + 1
      GO TO 11
      ELSE
      IYR = 2000
   12 CONTINUE
      IF ((IDJ.GE.IDJULI(IYR,1,1)).AND.(IDJ.LT.IDJULI(IYR+1,1,1))) THEN
        IY = IYR
        GO TO 19
      ENDIF
      IYR = IYR - 1
      GO TO 12
      ENDIF
   19 CONTINUE
      CALL CLYEAR (IY,1+IDJ-IDJULI(IY,1,1),IM,ID)
      RETURN
      END
