C ========================================
C   FUNCTIONS
C ========================================

      REAL FUNCTION THETA (P,T)
        THETA = T / (P/1.0E5)**(0.2E1/0.7E1)
      RETURN
      END

C      REAL FUNCTION ES (T)
C        ES = 0.611E3
C     +       * 1.0E1 ** (0.75E1 * (T-0.27316E3) / (T-0.3586E2))
C      RETURN
C      END

      REAL FUNCTION ES (T)
        ES = 0.611E3
     +       * EXP (0.1727E2 * (T-0.27316E3) / (T-0.3586E2))
      RETURN
      END

      REAL FUNCTION DES (T)
        DES = 0.611E3
     +        * EXP (0.1727E2 * (T-0.27316E3) / (T-0.3586E2))
     +        * 0.1727E2
     +        * 0.23730E3 / (T-0.3586E2)**2
      RETURN
      END

      REAL FUNCTION QSAT (P,T)
        QSAT = 0.622E0 * ES(T) / (P - 0.378E0 * ES(T))
      RETURN
      END

      REAL FUNCTION DQSAT (P,T)
        DQSAT = 0.622E0 * DES(T) / (P - 0.378E0 * ES(T))
     +          - 0.622E0 * ES(T) / (P - 0.378E0 * ES(T))**2
     +            * (- 0.378E0 * DES(T))
      RETURN
      END

      REAL FUNCTION QV (P,T,H)
        QV = 0.622E0 * H * ES(T) / (P - 0.378E0 * H * ES(T))
      RETURN
      END

      REAL FUNCTION RHUM (P,T,Q)
        RHUM = P * Q / ES(T) / (0.622E0 + 0.378E0 * Q)
      RETURN
      END

      REAL FUNCTION TVRT (T,Q,C)
        TVRT = T * (1.0E0 + 0.608E0 * Q - C)
      RETURN
      END

      REAL FUNCTION TDEW (P,T,Q)
        E = P * Q / (0.622E0 + 0.378E0 * Q)
        A = ALOG (E / 0.611E3)
        TDEW = (- A / 0.1727E2 * 0.3586E2 + 0.27316E3)
     +         / (1.0E0 - A / 0.1727E2)
      RETURN
      END

C      REAL FUNCTION TDEW (P,T,Q)
C      IF (Q.GE.QSAT(P,T)) THEN
C        TDEW = T
C        RETURN
C      ENDIF
C      DT = 0.1E0
C        TA  = T
C        QDA = QSAT(P,TA) - Q
C   11 CONTINUE
CC      IF (TA.LE.-0.80E2+0.27315E3) THEN
CC        TDEW = -0.80E2+0.27315E3
CC        RETURN
CC      ENDIF
C        TB  = TA - DT
C        QDB = QSAT(P,TB) - Q
C      IF (QDB.LE.0.0E0) THEN
C        TDEW = (QDA * TB - QDB * TA) / (QDA - QDB)
CC      IF (TDEW.LE.-0.80E2+0.27315E3) THEN
CC        TDEW = -0.80E2+0.27315E3
CC      ENDIF
C        RETURN
C      ENDIF
C        TA  = TB
C        QDA = QDB
C      GO TO 11
C      END

      REAL FUNCTION TWET (P,T,Q)
      CP = 0.1006E4
      AL = 0.2500E7
      IF (Q.GE.QSAT(P,T)) THEN
        TWET = T
        RETURN
      ENDIF
      DT = 0.1E0
        TA  = T
        QDA = QSAT(P,TA) - CP/AL*(T-TA) - Q
   11 CONTINUE
C      IF (TA.LE.-0.80E2+0.27315E3) THEN
C        TWET = -0.80E2+0.27315E3
C        RETURN
C      ENDIF
        TB  = TA - DT
        QDB = QSAT(P,TB) - CP/AL*(T-TB) - Q
      IF (QDB.LE.0.0E0) THEN
        TWET = (QDA * TB - QDB * TA) / (QDA - QDB)
C      IF (TWET.LE.-0.80E2+0.27315E3) THEN
C        TWET = -0.80E2+0.27315E3
C      ENDIF
        RETURN
      ENDIF
        TA  = TB
        QDA = QDB
      GO TO 11
      END

      REAL FUNCTION TCND (P,T,Q)
      IF (Q.GE.QSAT(P,T)) THEN
        TCND = T
        RETURN
      ENDIF
      DT = 0.1E0
        TA  = T
        PA  = P * (TA/T)**(0.7E1/0.2E1)
        QDA = QSAT(PA,TA) - Q
   11 CONTINUE
C      IF (TA.LE.-0.80E2+0.27315E3) THEN
C        TCND = -0.80E2+0.27315E3
C        RETURN
C      ENDIF
        TB  = TA - DT
        PB  = P * (TB/T)**(0.7E1/0.2E1)
        QDB = QSAT(PB,TB) - Q
      IF (QDB.LE.0.0E0) THEN
        TCND = (QDA * TB - QDB * TA) / (QDA - QDB)
C      IF (TCND.LE.-0.80E2+0.27315E3) THEN
C        TCND = -0.80E2+0.27315E3
C      ENDIF
        RETURN
      ENDIF
        TA  = TB
        QDA = QDB
      GO TO 11
      END

      REAL FUNCTION THETAE (P,T,Q)
      CP = 0.1006E4
      AL = 0.2500E7
      R = Q / (1.0E0 - Q)
        THETAE = THETA(P,T) * EXP(AL*R/(CP*TCND(P,T,Q)))
      RETURN
      END

      REAL FUNCTION GAMMAD ()
      GC = 0.9807E1
      CP = 0.1006E4
        GAMMAD = GC / CP
      RETURN
      END

      REAL FUNCTION GAMMAW (P,T)
      GC = 0.9807E1
      RC = 0.2870E3
      CP = 0.1006E4
      AL = 0.2500E7
        GAMMAW = GC / CP
     +           * (1.0E0+AL*0.622E0*ES(T)/(P*RC*T))
     +           / (1.0E0+AL*0.622E0*DES(T)/(CP*P))
      RETURN
      END

      REAL FUNCTION RHUMTW (P,T,TW)
      RHUMTW = 1.0E0-(T-TW)/(T-TWET(P,T,0.0E0))
      IF (RHUMTW.LE.0.0E0) THEN
        RHUMTW = 0.0E0
        RETURN
      ENDIF
      IF (RHUMTW.GE.1.0E0) THEN
        RHUMTW = 1.0E0
        RETURN
      ENDIF
      DH = 1.0E-3
      DO 11 I=1,5
      HA = RHUMTW - 0.5E0*DH
      HB = RHUMTW + 0.5E0*DH
      TDA = TWET(P,T,QV(P,T,HA))
      TDB = TWET(P,T,QV(P,T,HB))
      RHUMTW = (HA * (TDB-TW) + HB * (TW-TDA)) / (TDB-TDA)
   11 CONTINUE
      RETURN
      END
