C ========================================
C   FUNCTIONS
C ========================================

      REAL FUNCTION UNESCO (T,S,P)
      REAL*8 TT,SS,PP,AKW,AK0,AK,RW,R0,R,DSQRT,SS15,PP2
C   T: Temperature [deg.C]
C   S: Salinity [psu]
C   P: Pressure [d bar]
      TT = DBLE(T)
      SS = DBLE(S)
      PP = 0.1D0 * DBLE(P)
      PP2 = PP**2
      SS15 = DSQRT(SS**3)
      AKW = + 1.965221D+04
     +      + 1.484206D+02 * TT    - 2.327105D+00 * TT**2
     +      + 1.360477D-02 * TT**3 - 5.155288D-05 * TT**4
      AK0 = AKW
     +      + SS   * (+ 5.467460D+01 - 6.034590D-01 * TT
     +                               + 1.099870D-02 * TT**2
     +                               - 6.167000D-05 * TT**3)
     +      + SS15 * (+ 7.944000D-02 + 1.648300D-02 * TT
     +                               - 5.300900D-04 * TT**2)
      AK  = AK0
     +      + PP       * (+ 3.239908D+00 + 1.437130D-03 * TT
     +                                   + 1.160920D-04 * TT**2
     +                                   - 5.779050D-07 * TT**3)
     +      + PP * SS  * (+ 2.283800D-03 - 1.098100D-05 * TT
     +                                   - 1.607800D-06 * TT**2)
     +      + 1.910750D-4 * PP * SS15
     +      + PP2      * (+ 8.509350D-05 - 6.122930D-06 * TT
     +                                   + 5.278700D-08 * TT**2)
     +      + PP2 * SS * (- 9.934800D-07 + 2.081600D-08 * TT
     +                                   + 9.169700D-10 * TT**2)
      RW  = + 9.99842594D+02
     +      + 6.793952D-02 * TT    - 9.095290D-03 * TT**2
     +      + 1.001685D-04 * TT**3 - 1.120083D-06 * TT**4
     +      + 6.536332D-09 * TT**5
      R0  = RW
     +      + SS   * (+ 8.244930D-01 - 4.089900D-03 * TT
     +                               + 7.643800D-05 * TT**2
     +                               - 8.246700D-07 * TT**3
     +                               + 5.387500D-09 * TT**4)
     +      + SS15 * (- 5.724660D-03 + 1.022700D-04 * TT
     +                               - 1.654600D-06 * TT**2)
     +      + 4.831400D-04 * SS**2
      R   = R0 / (1.0 - PP / AK)
      UNESCO = REAL(R)
      RETURN
      END

      REAL FUNCTION PTEMP (T,S,P)
      REAL*8 TT1,TT2
C   T: Temperature [deg.C]
C   S: Salinity [psu]
C   P: Pressure [d bar]
      P0 = 0.0E0
      C = 0.40E4
      DP = 1.0E0
      TT2 = DBLE(T)
      P2 = P
      NMAX = 1+INT((P-P0)/DP)
      DP = (P-P0)/REAL(NMAX)
      DO 11 N=1,NMAX
      P1 = P2-DP
      A2 = 1.0E0 / UNESCO (REAL(TT2),S,P2)
      A1 = 1.0E0 / UNESCO (REAL(TT2),S,P1)
      TT1 = TT2 - DBLE((1.0E4*0.5E0*(P1+P2)) * (A1-A2) / C)
      TT2 = TT1
      P2 = P1
   11 CONTINUE
      PTEMP = REAL(TT2)
      RETURN
      END

      REAL FUNCTION SIGMT (T,S)
C   T: Temperature [deg.C]
C   S: Salinity [psu]
      SIGMT = UNESCO (T,S,0.0E0) - 1.0E3
      RETURN
      END

      REAL FUNCTION SIGMTH (T,S,P)
C   T: Temperature [deg.C]
C   S: Salinity [psu]
C   P: Pressure [d bar]
      SIGMTH = UNESCO (PTEMP(T,S,P),S,0.0E0) - 1.0E3
      RETURN
      END
