c Output : Plank(T,L) : Radiation power per wavelength [W/m^3]
c                       Double precision
c Input  : T          : Temperature [K], Double precision
c        : L          : Wavelength [m], Double precision

      DOUBLE PRECISION FUNCTION PLANCK (T,L)
      DOUBLE PRECISION T,L,PI,H,C,K,C1,C2
      PI = 3.1415926535D+00
      H  = 6.62607D-34
      C  = 2.99792D+08
      K  = 1.38066D-23
      C1 = DBLE(2) * PI * H * C**2
      C2 = H * C / K
      PLANCK = C1 / (L**5) / (DEXP(C2/L/T)-1.0D+00)
      RETURN
      END
