      WRITE(6,*) 'T [deg.C], T-Twet [deg.C] ?'
      READ (5,*) T,DTW
      P = 1013.25
      TW = T - DTW
      WRITE(6,'(A7,F5.1,A2)')
     +  'H    = ',
     +  1.0E2 * RHUM (1.0E2*P,T+0.27315E3,TW+0.27315E3),
     +  ' %'

C      WRITE(6,*) 'T [deg.C], H [%] ?'
C      READ (5,*) T,H
C      P = 1013.25
C      WRITE(6,'(A7,F5.1)')
C     +  'DI   = ',
C     +  DI (1.0E2*P,T+0.27315E3,1.0E-2*H)

C      WRITE(6,*) 'T [deg.C], H [%], Tb [deg.C] ?'
C      READ (5,*) T,H,TB
C      P = 1013.25
C      WRITE(6,'(A7,F5.1,A6)')
C     +  'WBGT = ',
C     +  WBGT (1.0E2*P,T+0.27315E3,1.0E-2*H,TB+0.27315E3)-0.27315E3,
C     +  ' deg.C'

      STOP
      END

C ========================================
C   FUNCTIONS
C ========================================

      REAL FUNCTION ES (T)
        ES = 0.611E3
     +       * EXP (0.1727E2 * (T-0.27316E3) / (T-0.3586E2))
      RETURN
      END

      REAL FUNCTION RHUM (P,T,TW)
      A = 0.5E0
C      A = 0.44E0
        RHUM = (1.0E-2*ES(TW)-A/0.755E3*1.0E-2*P*(T-TW))
     +         / (1.0E-2*ES(T))
      RETURN
      END

      REAL FUNCTION TWET (P,T,H)
        TW = T
   11 CONTINUE
        TW1 = TW - 1.0E-3 * (RHUM(P,T,TW)-H)
     +            / (RHUM(P,T,TW)-RHUM(P,T,TW-1.0E-3))
        DTW = TW1 - TW
        TW = TW1
      IF (ABS(DTW).LE.1.0E-3) GO TO 19
      GO TO 11
   19 CONTINUE
        TWET = TW
      RETURN
      END

      REAL FUNCTION DI (P,T,H)
        DI = 0.72E0 * (T-0.27315E3 + TWET(P,T,H)-0.27315E3) + 0.406E2
      RETURN
      END

C      REAL FUNCTION DI (T,H)
C        DI = 0.81E0 * (T-0.27315E3)
C     +       + H * (0.99E0*(T-0.27315E3)-0.143E2) + 0.463E2
C      RETURN
C      END

      REAL FUNCTION WBGT (P,T,H,TB)
C   WBGT =   -21 deg.C : Almost safe (Take in water suitably).
C   WBGT = 21-25 deg.C : Caution (Take in water frequently).
C   WBGT = 25-28 deg.C : Warning (Take a rest frequently).
C   WBGT = 28-31 deg.C : Severe warning (Stop intense exercise).
C   WBGT = 31-   deg.C : Stop (Stop exercise).
C   Outdoor:
        WBGT = 0.7E0 * TWET(P,T,H) + 0.2E0 * TB + 0.1E0 * T
C   Indoor:
C        WBGT = 0.7E0 * TWET(P,T,H) + 0.3E0 * TB
      RETURN
      END
